/* datastructures.c - cwebldap datastructure functions
 * Copyright (C) 2001 CryptNET, V. Alex Brennen
 *
 * This file is part of cwebldap.
 *
 * cwebldap is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * cwebldap is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "datastructures.h"


void free_name_value_pair_dllst(struct name_value_pair_dllst *the_list)
{
	struct name_value_pair_dllst *walk_pair;
	struct name_value_pair_dllst *next_pair;

	if(the_list != NULL)
	{
		walk_pair = (struct name_value_pair_dllst *)get_first_pair(the_list);
		while(walk_pair != NULL)
		{
			next_pair = walk_pair->next;
			free(walk_pair->name);
			free(walk_pair->value);
			free(walk_pair);
			walk_pair = next_pair;
		}
	}

	return;
}

struct name_value_pair_dllst *get_first_pair(struct name_value_pair_dllst *the_list)
{
	if(the_list != NULL)
	{
		while(the_list->prev != NULL)
		{
			the_list = the_list->prev;
		}
	}

	return the_list;
}

char *get_value(struct name_value_pair_dllst *the_list,char *name)
{
	if(the_list == NULL) return NULL;
	/* Rewind to the beginning */
	the_list = get_first_pair(the_list);

	while(memcmp(the_list->name,name,strlen(name)) != 0)
	{
		the_list = the_list->next;
		if(the_list == NULL) return NULL;
	}

	return the_list->value;
}

struct attr_equivs *get_attr_equivs(struct attr_equivs *equivs, char *name)
{
	if(equivs == NULL) printf("equivs is null!\n");
	equivs = (struct attr_equivs *)get_first_attr_equiv(equivs);
	while(equivs != NULL)
	{
		if(memcmp(equivs->dir_name,name,strlen(equivs->dir_name))==0)
		{
			return equivs;
		}
		else
		{
			equivs = equivs->next;
		}
	}

	return equivs;
}

struct attr_equivs *get_first_attr_equiv(struct attr_equivs *equivs)
{
	if(equivs != NULL)
	{
		while(equivs->prev != NULL)
		{
			equivs = equivs->prev;
		}
	}

	return equivs;
}

struct value_dllst *get_first_value(struct value_dllst *values)
{
	if(values != NULL)
	{
		while(values->prev != NULL)
		{
			values = values->prev;
		}
	}

	return values;
}

void free_equiv_vals(struct attr_equivs *equivs)
{
	if(equivs != NULL)
	{
		struct value_dllst *walk_values;

		walk_values = (struct value_dllst *)get_first_value(equivs->values);
		while(walk_values != NULL)
		{
			free(walk_values->value);
			walk_values = walk_values->next;
		}
	}

	return;
}

void free_attr_equivs(struct attr_equivs *equivs)
{
	equivs = (struct attr_equivs *)get_first_attr_equiv(equivs);
	if(equivs != NULL)
	{
		struct value_dllst *walk_values;

		free(equivs->name);
		free(equivs->dir_name);

		walk_values = (struct value_dllst *)get_first_value(equivs->values);
		while(walk_values != NULL)
		{
			free(walk_values->value);
			walk_values = walk_values->next;
		}
	}

	return;
}
