/* datastructures.h - cwebldap datastructure functions header file
 * Copyright (C) 2001 CryptNET, V. Alex Brennen
 *
 * This file is part of cwebldap.
 *
 * cwebldap is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * cwebldap is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef DATASTRUCTURES
#define DATASTRUCTURES
#include <stdio.h>


struct cwebldap_config
{
        unsigned char ldapsrvr_name[60];
        unsigned char ldapsrvr_port[10];
	unsigned char root[60];
	unsigned int bind_anon;
	unsigned char bind_cn[120];
	unsigned char bind_passwd[120];
	unsigned char attrs[120];
	int max_rslts;
	struct timeval  *max_qtime;

	unsigned char header_path[300];
	unsigned char footer_path[300];
};

struct name_value_pair_dllst
{
	unsigned char *name;
	unsigned char *value;

	struct name_value_pair_dllst *prev;
	struct name_value_pair_dllst *next;
};

struct value_dllst
{
	unsigned char *value;

	struct value_dllst *next;
	struct value_dllst *prev;
};


struct attr_equivs
{
	unsigned char *name;
	unsigned char *dir_name;
	struct value_dllst *values;

	struct attr_equivs *prev;
	struct attr_equivs *next;
};

void free_name_value_pair_dllst(struct name_value_pair_dllst *);
struct name_value_pair_dllst *get_first_pair(struct name_value_pair_dllst *);
char *get_value(struct name_value_pair_dllst *,char *);

struct attr_equivs *get_first_attr_equiv(struct attr_equivs *);
struct attr_equivs *get_attr_equivs(struct attr_equivs *, char *);
struct value_dllst *get_first_value(struct value_dllst *);
void free_equiv_vals(struct attr_equivs *);
void free_attr_equivs(struct attr_equivs *);
#endif
